import 'package:flutter/material.dart';
import 'package:libui/async/async_loader.dart';

enum _Status { wait, ok, error }

class Async extends StatefulWidget {
  final List<AsyncLoader> list;
  final Widget wait;
  final Widget ok;
  final Widget error;

  Async(
      {Key key,
      @required this.list,
      @required this.wait,
      @required this.ok,
      @required this.error})
      : super(key: key);

  _AsyncState createState() => _AsyncState();
}

class _AsyncState extends State<Async> {
  _Status _status = _Status.wait;

  void check(loader) {
    if (_status == _Status.wait) {
      for (var loader in widget.list) {
        if (loader.ready() == false) return;
      }
      _status = _Status.ok;
    }
  }

  void somethingWrong() {
    _status = _Status.error;
  }

  void retry() {
    _status = _Status.wait;
    widget.list.forEach((loader) {
      if (loader.ready() == false) {
        Future.microtask(() {
          loader.load(context).then((_) {
            check(loader);
            loader.redraw();
          }).catchError((err) {
            print('catch $err');
            somethingWrong();
          });
        });
      }
    });
  }

  @override
  void initState() {
    retry();
    super.initState();
  }

  @override
  void dispose() {
    widget.list.forEach((loader) => loader.reset());
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    switch (_status) {
      case _Status.ok:
        return widget.ok;
      case _Status.error:
        return widget.error;
      default:
        return widget.wait;
    }
  }
}
