import 'dart:async';
import 'package:flutter/material.dart';
import 'package:libui/i18n/i18n_controller.dart';

class I18nDelegate extends LocalizationsDelegate<I18nController> {
  static String localeId;

  @override
  bool isSupported(Locale locale) => isSupportedLocale(locale);

  @override
  Future<I18nController> load(Locale l) async {
    localeId = localeToId(l);
    return I18nController.current;
  }

  @override
  bool shouldReload(I18nDelegate old) => false;
}

Locale determineLocale(List<Locale> locales) {
  print('determine Locale');
  for (var locale in locales) {
    if (isSupportedLocale(locale)) {
      print('choose ${locale.languageCode}_${locale.countryCode}');
      return locale;
    }
  }
  var locale = idToLocale(Locales[0]);
  print('use default ${locale.languageCode}_${locale.countryCode}');
  return locale;
}

List<Locale> supportedLocales() {
  print('ask supported locales');
  return Locales.map((id) => idToLocale(id)).toList();
}
