import 'package:flutter/material.dart';
import 'package:flutter_test/flutter_test.dart';
import 'package:libui/async/async.dart';
import 'package:provider/provider.dart';
import 'mock_controller.dart';
import '../mock/mock_async_views.dart';

void main() {
  TestWidgetsFlutterBinding.ensureInitialized();
  setUp(() async {});

  group('async', () {
    testWidgets('should load', (WidgetTester tester) async {
      await tester.pumpWidget(MaterialApp(
        home: Material(
          child: TestWidget(),
        ),
      ));
      await tester.pumpAndSettle();
      expect(MockBusyView.count, greaterThan(0));
      expect(MockOkView.count, greaterThan(0));
    });
  });
}

class TestWidget extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return MultiProvider(
      providers: [
        ChangeNotifierProvider<MockController>(
          create: (context) => MockController(),
        ),
      ],
      child: Consumer<MockController>(
          builder: (context, ctrl, child) => Async(
                list: [ctrl],
                wait: MockBusyView(),
                error: MockErrorView(),
                ok: MockOkView(),
              )),
    );
  }
}
